unit FenetreForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, DXSounds, MMSystem, Wave, DXClass;

const
  NbVoiesDefaut=4;
  NbVoixDefaut=4;
  FreqEchanVoix1Defaut=0;
  FreqEchanVoix2Defaut=-25;
  FreqEchanVoix3Defaut=100;
  FreqEchanVoix4Defaut=-65;
  PoidsVoix1Defaut=10;
  PoidsVoix2Defaut=7;
  PoidsVoix3Defaut=7;
  PoidsVoix4Defaut=24;
  PoidsFichier1Defaut=20;
  PoidsFichier2Defaut=20;
  PoidsFichier3Defaut=20;
  PoidsFichier4Defaut=20;
  PoidsFichier5Defaut=43;
  PosTetLectInfDefaut=0;
  PosTetLectSupDefaut=100;

type
  TAudio = array[1..4] of TAudioFileStream;
  TWaveFormat = array[1..4] of TWaveFormatEx;
  TFenetre = class(TDXForm)
// Son ////////////////////////////////////
    DXSound: TDXSound;
    DXTimer: TDXTimer;
// Interface //////////////////////////////
    Poeme: TRichEdit;
    Edit0: TEdit;      // nombre de voies de mixage
    Edit1: TEdit;      // nombre de voix
    Edit2: TEdit;      // frquence d'chantillonnage de la voix 1
    Edit3: TEdit;      // frquence d'chantillonnage de la voix 2
    Edit4: TEdit;      // frquence d'chantillonnage de la voix 3
    Edit5: TEdit;      // frquence d'chantillonnage de la voix 4
    Edit6: TEdit;      // poids de la voix 1
    Edit7: TEdit;      // poids de la voix 2
    Edit8: TEdit;      // poids de la voix 3
    Edit9: TEdit;      // poids de la voix 4
    Edit10: TEdit;     // poids du fichier 1.wav
    Edit11: TEdit;     // poids du fichier 2.wav
    Edit12: TEdit;     // poids du fichier 3.wav
    Edit13: TEdit;     // poids du fichier 4.wav
    Edit14: TEdit;     // poids du fichier 5.wav
    Edit15: TEdit;     // position de la tte de lecture (borne inf)
    Edit16: TEdit;     // position de la tte de lecture (borne sup)
    UpDown0: TUpDown;  // agit sur Edit0   [0;4]
    UpDown1: TUpDown;  // agit sur Edit1   [0;4]
    UpDown2: TUpDown;  // agit sur Edit2   [-100;100]
    UpDown3: TUpDown;  // agit sur Edit3   [-100;100]
    UpDown4: TUpDown;  // agit sur Edit4   [-100;100]
    UpDown5: TUpDown;  // agit sur Edit5   [-100;100]
    UpDown6: TUpDown;  // agit sur Edit6   [0;100]
    UpDown7: TUpDown;  // agit sur Edit7   [0;100]
    UpDown8: TUpDown;  // agit sur Edit8   [0;100]
    UpDown9: TUpDown;  // agit sur Edit9   [0;100]
    UpDown10: TUpDown; // agit sur Edit10  [0;100]
    UpDown11: TUpDown; // agit sur Edit11  [0;100]
    UpDown12: TUpDown; // agit sur Edit12  [0;100]
    UpDown13: TUpDown; // agit sur Edit13  [0;100]
    UpDown14: TUpDown; // agit sur Edit14  [0;100]
    UpDown15: TUpDown; // agit sur Edit15  [0;100]
    UpDown16: TUpDown; // agit sur Edit16  [0;100]
    Hasard: TButton;   // pour obtenir une nouvelle interface (cercle)
    Quitter: TButton;  // pour quitter le programme
    Defaut: TButton;   // paramtres par dfaut des diffrents Edit
    Save: TButton;     // enregistrer vos paramtres dans un fichier
    Load: TButton;     // charger vos paramtres depuis un fichier
    Legende: TLabel;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;


// Procdures /////////////////////////////
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);

    procedure Edit0Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Edit10Change(Sender: TObject);
    procedure Edit11Change(Sender: TObject);
    procedure Edit12Change(Sender: TObject);
    procedure Edit13Change(Sender: TObject);
    procedure Edit14Change(Sender: TObject);

    procedure UpDown0MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown5MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown6MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown7MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown8MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown9MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown10MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown11MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown12MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown13MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown14MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure HasardMouseMove(Sender: TObject; Shift: TShiftState; X,
     Y: Integer);
    procedure DefautMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SaveMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LoadMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure QuitterMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

    procedure HasardClick(Sender: TObject);
    procedure DefautClick(Sender: TObject);
    procedure QuitterClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure LoadClick(Sender: TObject);
    procedure UpDown15MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown16MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Edit15Change(Sender: TObject);
    procedure Edit16Change(Sender: TObject);

  private
    Audio: TAudio;
    NbVoies: Integer;
    NbVoix: Integer;
    FreqEchanVoix1: Integer;
    FreqEchanVoix2: Integer;
    FreqEchanVoix3: Integer;
    FreqEchanVoix4: Integer;
    PoidsVoix1: Integer;
    PoidsVoix2: Integer;
    PoidsVoix3: Integer;
    PoidsVoix4: Integer;
    PoidsTotalVoix: Integer;
    PoidsFichier1: Integer;
    PoidsFichier2: Integer;
    PoidsFichier3: Integer;
    PoidsFichier4: Integer;
    PoidsFichier5: Integer;
    PoidsTotalFichiers: Integer;
    PosTetLectInf: Integer;
    PosTetLectSup: Integer;

  public
    {}
  end;

var
  WaveFormat: TWaveFormat;
  Fenetre: TFenetre;
  X0, Y0, R, Teta: Integer;         // variables destines au cercle

implementation

{$R *.DFM}

////////////////////////////////////////////////////////////////////////////////
// CREATION DE LA FENETRE PRINCIPALE
////////////////////////////////////////////////////////////////////////////////

procedure TFenetre.FormCreate(Sender: TObject);
var
  i: Integer;
begin

// Initialisation //////////////////////////////////////////////////////////////

  Randomize;

// Fenetre /////////////////////////////////////////////////////////////////////

  Fenetre.Width:=800;
  Fenetre.Height:=600;
  Fenetre.Left:=0;
  Fenetre.Top:=0;

// Interface ///////////////////////////////////////////////////////////////////
  Poeme.Left:=150;
  X0:=Poeme.Left+168;
  Y0:=370;
  R:=150;
  Teta:=Random(360);
  Edit0.Left :=Round(X0+R*cos(Teta));
  Edit0.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit1.Left :=Round(X0+R*cos(Teta));
  Edit1.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit2.Left :=Round(X0+R*cos(Teta));
  Edit2.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit3.Left :=Round(X0+R*cos(Teta));
  Edit3.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit4.Left :=Round(X0+R*cos(Teta));
  Edit4.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit5.Left :=Round(X0+R*cos(Teta));
  Edit5.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit6.Left :=Round(X0+R*cos(Teta));
  Edit6.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit7.Left :=Round(X0+R*cos(Teta));
  Edit7.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit8.Left :=Round(X0+R*cos(Teta));
  Edit8.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit9.Left :=Round(X0+R*cos(Teta));
  Edit9.Top  :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit10.Left:=Round(X0+R*cos(Teta));
  Edit10.Top :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit11.Left:=Round(X0+R*cos(Teta));
  Edit11.Top :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit12.Left:=Round(X0+R*cos(Teta));
  Edit12.Top :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit13.Left:=Round(X0+R*cos(Teta));
  Edit13.Top :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit14.Left:=Round(X0+R*cos(Teta));
  Edit14.Top :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit15.Left:=Round(X0+R*cos(Teta));
  Edit15.Top :=Round(Y0+R*sin(Teta));
  Teta:=Random(360);
  Edit16.Left:=Round(X0+R*cos(Teta));
  Edit16.Top :=Round(Y0+R*sin(Teta));

  Quitter.Width:=60;
  Quitter.Height:=120;                     // 600 divis par 5 boutons
  Quitter.Left:=800-Quitter.Width;
  Quitter.Top :=600-Quitter.Height;

  Load.Width:=Quitter.Width;
  Load.Height:=Quitter.Height;
  Load.Left:=Quitter.Left;
  Load.Top :=Quitter.Top-Quitter.Height;

  Save.Width:=Quitter.Width;
  Save.Height:=Quitter.Height;
  Save.Left:=Quitter.Left;
  Save.Top :=Load.Top-Quitter.Height;

  Defaut.Width:=Quitter.Width;
  Defaut.Height:=Quitter.Height;
  Defaut.Left:=Quitter.Left;
  Defaut.Top:=Save.Top-Quitter.Height;

  Hasard.Width:=Quitter.Width;
  Hasard.Height:=Quitter.Height;
  Hasard.Left:=Quitter.Left;
  Hasard.Top :=Defaut.Top-Quitter.Height;

  Legende.Left:=15;
  Legende.Top:=575;

// Initialisation //////////////////////////////////////////////////////////////

  try

  DefautClick(Sender);

  DXSound.Initialize;
  for i:=1 to 4 do begin
    Audio[i]:=TAudioFileStream.Create(DXSound.DSound);
    Audio[i].AutoUpdate:=True;
    Audio[i].BufferLength:=1000;
    // Audio[i].FileName est  mettre avant Audio[i].Looped sinon gros crash !
    Audio[i].FileName:=IntToStr(1+Random(5))+'.wav';
    Audio[i].Looped:=False;  // lecture en boucle du fichier
    Audio[i].Volume:=0;      // volume de la lecture  (0 : maximum)
    Audio[i].Pan:=0;         // balance (stro)      (0 : quilibr)
    MakePCMWaveFormatEx(WaveFormat[i],
                        44100,
                        Audio[i].Format.wBitsPerSample,
                        2);
    DXSound.Primary.SetFormat(WaveFormat[i]);
  end;

  except
    Exit;
  end;
  
end;

////////////////////////////////////////////////////////////////////////////////
// LORS DE LA FERMETURE DE LA FENETRE PRINCIPALE                            OK
////////////////////////////////////////////////////////////////////////////////

procedure TFenetre.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:integer;
begin
  for i:=1 to NbVoies do begin
    Audio[i].Free;
    Audio[i]:=nil;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// UTILISATION DU TIMER
////////////////////////////////////////////////////////////////////////////////

procedure TFenetre.DXTimerTimer(Sender: TObject; LagCount: Integer);
var
  i: Integer;
  Taille: Integer;
begin

// Choix des fichiers  lire ///////////////////////////////////////////////////

  try

  PoidsTotalFichiers:= PoidsFichier1
                     + PoidsFichier2
                     + PoidsFichier3
                     + PoidsFichier4
                     + PoidsFichier5;

  if PoidsTotalFichiers<>0 then for i:=1 to NbVoies do begin
    if random(PoidsTotalFichiers)<PoidsFichier1 then Audio[i].FileName:='1.wav'
    else if random(PoidsTotalFichiers
                  -PoidsFichier1)<PoidsFichier2 then Audio[i].FileName:='2.wav'
    else if random(PoidsTotalFichiers
                  -PoidsFichier1
                  -PoidsFichier2)<PoidsFichier3 then Audio[i].FileName:='3.wav'
    else if random(PoidsTotalFichiers
                  -PoidsFichier1
                  -PoidsFichier2
                  -PoidsFichier3)<PoidsFichier4 then Audio[i].FileName:='4.wav'
    else Audio[i].FileName:='5.wav';
  end;

  except
    Exit;
  end;

// Choix des voix //////////////////////////////////////////////////////////////

  try

  PoidsTotalVoix:= PoidsVoix1                                 
                 + PoidsVoix2
                 + PoidsVoix3
                 + PoidsVoix4;

  if PoidsTotalVoix<>0 then for i:=1 to NbVoies do begin
    if random(PoidsTotalVoix)<PoidsVoix1
      then Audio[i].Frequency:=44100+412*(FreqEchanVoix1)
    else if random(PoidsTotalVoix
                  -PoidsVoix1)<PoidsVoix2
      then Audio[i].Frequency:=44100+412*(FreqEchanVoix2)
    else if random(PoidsTotalVoix
                  -PoidsVoix1
                  -PoidsVoix2)<PoidsVoix3
      then Audio[i].Frequency:=44100+412*(FreqEchanVoix3)
    else Audio[i].Frequency:=44100+412*(FreqEchanVoix4);
  end;

  except
    Exit;
  end;

// Position de la tte de lecture //////////////////////////////////////////////

  if (NbVoies<>0) and (NbVoix<>0) then
  for i:=1 to NbVoies do begin
  try
    DXTimer.Interval:=2000;
    // Audio[i].Position:=Random(Audio[i].Size);
    Taille:=Audio[i].Size;
    Audio[i].Position:=(PosTetLectInf*Taille Div Updown16.Max)
      + Random((PosTetLectSup-PosTetLectInf)*Taille Div Updown16.Max);
    Audio[i].Stop;
    Audio[i].Play;
  except
    Exit;
  end;
  end;

end;

////////////////////////////////////////////////////////////////////////////////
// EN CAS DE CHANGEMENT AU NIVEAU DES EDIT DE L'INTERFACE
////////////////////////////////////////////////////////////////////////////////

procedure TFenetre.Edit0Change(Sender: TObject);
begin
  NbVoies:=StrToInt(Edit0.Text);
  if NbVoies<4 then Audio[4].Stop;
  if NbVoies<3 then Audio[3].Stop;
  if NbVoies<2 then Audio[2].Stop;
  if NbVoies<1 then Audio[1].Stop;
end;

procedure TFenetre.Edit1Change(Sender: TObject);
var
  i: Integer;
begin
  NbVoix:=StrToInt(Edit1.Text);
  case NbVoix of
  0: begin
       Edit2.Visible:=False; UpDown2.Visible:=False;
       Edit3.Visible:=False; UpDown3.Visible:=False;
       Edit4.Visible:=False; UpDown4.Visible:=False;
       Edit5.Visible:=False; UpDown5.Visible:=False;
       Edit6.Visible:=False; UpDown6.Visible:=False;
       Edit7.Visible:=False; UpDown7.Visible:=False;
       Edit8.Visible:=False; UpDown8.Visible:=False;
       Edit9.Visible:=False; UpDown9.Visible:=False;
       UpDown6.Position:=0;                                        // PoidsVoix1
       Updown7.Position:=0;                                        // PoidsVoix2
       Updown8.Position:=0;                                        // PoidsVoix3
       Updown9.Position:=0;                                        // PoidsVoix4
       for i:=1 to 4 do Audio[i].Stop;
     end;
  1: begin
       Edit2.Visible:=True; UpDown2.Visible:=True;
       Edit3.Visible:=False; UpDown3.Visible:=False;
       Edit4.Visible:=False; UpDown4.Visible:=False;
       Edit5.Visible:=False; UpDown5.Visible:=False;
       Edit6.Visible:=True; UpDown6.Visible:=True;
       Edit7.Visible:=False; UpDown7.Visible:=False;
       Edit8.Visible:=False; UpDown8.Visible:=False;
       Edit9.Visible:=False; UpDown9.Visible:=False;
       if PoidsVoix1=0 then Updown6.Position:=PoidsVoix1Defaut;    // PoidsVoix1
       Updown7.Position:=0;                                        // PoidsVoix2
       Updown8.Position:=0;                                        // PoidsVoix3
       Updown9.Position:=0;                                        // PoidsVoix4
     end;
  2: begin
       Edit2.Visible:=True; UpDown2.Visible:=True;
       Edit3.Visible:=True; UpDown3.Visible:=True;
       Edit4.Visible:=False; UpDown4.Visible:=False;
       Edit5.Visible:=False; UpDown5.Visible:=False;
       Edit6.Visible:=True; UpDown6.Visible:=True;
       Edit7.Visible:=True; UpDown7.Visible:=True;
       Edit8.Visible:=False; UpDown8.Visible:=False;
       Edit9.Visible:=False; UpDown9.Visible:=False;
       if PoidsVoix1=0 then Updown6.Position:=PoidsVoix1Defaut;    // PoidsVoix1
       if PoidsVoix2=0 then Updown7.Position:=PoidsVoix2Defaut;    // PoidsVoix2
       Updown8.Position:=0;                                        // PoidsVoix3
       Updown9.Position:=0;                                        // PoidsVoix4
     end;
  3: begin
       Edit2.Visible:=True; UpDown2.Visible:=True;
       Edit3.Visible:=True; UpDown3.Visible:=True;
       Edit4.Visible:=True; UpDown4.Visible:=True;
       Edit5.Visible:=False; UpDown5.Visible:=False;
       Edit6.Visible:=True; UpDown6.Visible:=True;
       Edit7.Visible:=True; UpDown7.Visible:=True;
       Edit8.Visible:=True; UpDown8.Visible:=True;
       Edit9.Visible:=False; UpDown9.Visible:=False;
       if PoidsVoix1=0 then Updown6.Position:=PoidsVoix1Defaut;    // PoidsVoix1
       if PoidsVoix2=0 then Updown7.Position:=PoidsVoix2Defaut;    // PoidsVoix2
       if PoidsVoix3=0 then Updown8.Position:=PoidsVoix3Defaut;    // PoidsVoix3
       Updown9.Position:=0;                                        // PoidsVoix4
     end;
  4: begin
       Edit2.Visible:=True; UpDown2.Visible:=True;
       Edit3.Visible:=True; UpDown3.Visible:=True;
       Edit4.Visible:=True; UpDown4.Visible:=True;
       Edit5.Visible:=True; UpDown5.Visible:=True;
       Edit6.Visible:=True; UpDown6.Visible:=True;
       Edit7.Visible:=True; UpDown7.Visible:=True;
       Edit8.Visible:=True; UpDown8.Visible:=True;
       Edit9.Visible:=True; UpDown9.Visible:=True;
       // attention PoidsVoixDefaut<>0 sinon bouclage
       if PoidsVoix1=0 then Updown6.Position:=PoidsVoix1Defaut;    // PoidsVoix1
       if PoidsVoix2=0 then Updown7.Position:=PoidsVoix2Defaut;    // PoidsVoix2
       if PoidsVoix3=0 then Updown8.Position:=PoidsVoix3Defaut;    // PoidsVoix3
       if PoidsVoix4=0 then Updown9.Position:=PoidsVoix4Defaut;    // PoidsVoix4
     end;
  end;
end;

procedure TFenetre.Edit2Change(Sender: TObject);
begin
  FreqEchanVoix1:=StrToInt(Edit2.Text);
  Audio[1].Frequency:=44100+412*(FreqEchanVoix1);
end;

procedure TFenetre.Edit3Change(Sender: TObject);
begin
  FreqEchanVoix2:=StrToInt(Edit3.Text);
  Audio[2].Frequency:=44100+412*(FreqEchanVoix2);
end;

procedure TFenetre.Edit4Change(Sender: TObject);
begin
  FreqEchanVoix3:=StrToInt(Edit4.Text);
  Audio[3].Frequency:=44100+412*(FreqEchanVoix3);
end;

procedure TFenetre.Edit5Change(Sender: TObject);
begin
  FreqEchanVoix4:=StrToInt(Edit5.Text);
  Audio[4].Frequency:=44100+412*(FreqEchanVoix4);
end;

procedure TFenetre.Edit6Change(Sender: TObject);
begin
  PoidsVoix1:=StrToInt(Edit6.Text);
end;

procedure TFenetre.Edit7Change(Sender: TObject);
begin
  PoidsVoix2:=StrToInt(Edit7.Text);
end;

procedure TFenetre.Edit8Change(Sender: TObject);
begin
  PoidsVoix3:=StrToInt(Edit8.Text);
end;

procedure TFenetre.Edit9Change(Sender: TObject);
begin
  PoidsVoix4:=StrToInt(Edit9.Text);
end;

procedure TFenetre.Edit10Change(Sender: TObject);
begin
  PoidsFichier1:=StrToInt(Edit10.Text);
end;

procedure TFenetre.Edit11Change(Sender: TObject);
begin
  PoidsFichier2:=StrToInt(Edit11.Text);
end;

procedure TFenetre.Edit12Change(Sender: TObject);
begin
  PoidsFichier3:=StrToInt(Edit12.Text);
end;

procedure TFenetre.Edit13Change(Sender: TObject);
begin
  PoidsFichier4:=StrToInt(Edit13.Text);
end;

procedure TFenetre.Edit14Change(Sender: TObject);
begin
  PoidsFichier5:=StrToInt(Edit14.Text);
end;

procedure TFenetre.Edit15Change(Sender: TObject);
begin
  if StrToInt(Edit15.Text)<StrToInt(Edit16.Text)
  then PosTetLectInf:=StrToInt(Edit15.Text)
  else Updown15.Position:=Updown15.Position-1;
end;

procedure TFenetre.Edit16Change(Sender: TObject);
begin
  if StrToInt(Edit16.Text)>StrToInt(Edit15.Text)
  then PosTetLectSup:=StrToInt(Edit16.Text)
  else Updown16.Position:=Updown16.Position+1;
end;

procedure TFenetre.UpDown0MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='nombre de voies de mixage';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='nombre de voix';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='frquence d''chantillonnage de la voix 1';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='frquence d''chantillonnage de la voix 2';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown4MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='frquence d''chantillonnage de la voix 3';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown5MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='frquence d''chantillonnage de la voix 4';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown6MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids de la voix 1';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown7MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids de la voix 2';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown8MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids de la voix 3';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown9MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids de la voix 4';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown10MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids du fichier 1.wav';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown11MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids du fichier 2.wav';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown12MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids du fichier 3.wav';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown13MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids du fichier 4.wav';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown14MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='poids du fichier 5.wav';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown15MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  Legende.Caption:='position de la tte de lecture : borne infrieure';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.UpDown16MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  Legende.Caption:='position de la tte de lecture : borne suprieure';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.HasardMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='interface en roue libre';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.DefautMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='paramtres par dfaut';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.SaveMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='enregistrer vos paramtres';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.LoadMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='charger vos paramtres';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.QuitterMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='quitter';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Legende.Caption:='';
  Legende.Left:=Edit0.Width+X0-Legende.Width Div 2;
end;

procedure TFenetre.HasardClick(Sender: TObject);
begin
  Teta:=Random(360);
  Edit0.Left:=Round(X0+R*cos(Teta)); Edit0.Top:=Round(Y0+R*sin(Teta));
  UpDown0.AlignButton:=udLeft; UpDown0.AlignButton:=udRight;
  Teta:=Random(360);
  Edit1.Left:=Round(X0+R*cos(Teta)); Edit1.Top:=Round(Y0+R*sin(Teta));
  UpDown1.AlignButton:=udLeft; UpDown1.AlignButton:=udRight;
  Teta:=Random(360);
  Edit2.Left:=Round(X0+R*cos(Teta)); Edit2.Top:=Round(Y0+R*sin(Teta));
  UpDown2.AlignButton:=udLeft; UpDown2.AlignButton:=udRight;
  Teta:=Random(360);
  Edit3.Left:=Round(X0+R*cos(Teta)); Edit3.Top:=Round(Y0+R*sin(Teta));
  UpDown3.AlignButton:=udLeft; UpDown3.AlignButton:=udRight;
  Teta:=Random(360);
  Edit4.Left:=Round(X0+R*cos(Teta)); Edit4.Top:=Round(Y0+R*sin(Teta));
  UpDown4.AlignButton:=udLeft; UpDown4.AlignButton:=udRight;
  Teta:=Random(360);
  Edit5.Left:=Round(X0+R*cos(Teta)); Edit5.Top:=Round(Y0+R*sin(Teta));
  UpDown5.AlignButton:=udLeft; UpDown5.AlignButton:=udRight;
  Teta:=Random(360);
  Edit6.Left:=Round(X0+R*cos(Teta)); Edit6.Top:=Round(Y0+R*sin(Teta));
  UpDown6.AlignButton:=udLeft; UpDown6.AlignButton:=udRight;
  Teta:=Random(360);
  Edit7.Left:=Round(X0+R*cos(Teta)); Edit7.Top:=Round(Y0+R*sin(Teta));
  UpDown7.AlignButton:=udLeft; UpDown7.AlignButton:=udRight;
  Teta:=Random(360);
  Edit8.Left:=Round(X0+R*cos(Teta)); Edit8.Top:=Round(Y0+R*sin(Teta));
  UpDown8.AlignButton:=udLeft; UpDown8.AlignButton:=udRight;
  Teta:=Random(360);
  Edit9.Left:=Round(X0+R*cos(Teta)); Edit9.Top:=Round(Y0+R*sin(Teta));
  UpDown9.AlignButton:=udLeft; UpDown9.AlignButton:=udRight;
  Teta:=Random(360);
  Edit10.Left:=Round(X0+R*cos(Teta)); Edit10.Top:=Round(Y0+R*sin(Teta));
  UpDown10.AlignButton:=udLeft; UpDown10.AlignButton:=udRight;
  Teta:=Random(360);
  Edit11.Left:=Round(X0+R*cos(Teta)); Edit11.Top:=Round(Y0+R*sin(Teta));
  UpDown11.AlignButton:=udLeft; UpDown11.AlignButton:=udRight;
  Teta:=Random(360);
  Edit12.Left:=Round(X0+R*cos(Teta)); Edit12.Top:=Round(Y0+R*sin(Teta));
  UpDown12.AlignButton:=udLeft; UpDown12.AlignButton:=udRight;
  Teta:=Random(360);
  Edit13.Left:=Round(X0+R*cos(Teta)); Edit13.Top:=Round(Y0+R*sin(Teta));
  UpDown13.AlignButton:=udLeft; UpDown13.AlignButton:=udRight;
  Teta:=Random(360);
  Edit14.Left:=Round(X0+R*cos(Teta)); Edit14.Top:=Round(Y0+R*sin(Teta));
  UpDown14.AlignButton:=udLeft; UpDown14.AlignButton:=udRight;
  Teta:=Random(360);
  Edit15.Left:=Round(X0+R*cos(Teta)); Edit15.Top:=Round(Y0+R*sin(Teta));
  UpDown15.AlignButton:=udLeft; UpDown15.AlignButton:=udRight;
  Teta:=Random(360);
  Edit16.Left:=Round(X0+R*cos(Teta)); Edit16.Top:=Round(Y0+R*sin(Teta));
  UpDown16.AlignButton:=udLeft; UpDown16.AlignButton:=udRight;
end;

procedure TFenetre.DefautClick(Sender: TObject);
begin
  Updown0.Position:=NbVoiesDefaut;
  Updown1.Position:=NbVoixDefaut;
  Updown2.Position:=FreqEchanVoix1Defaut;
  Updown3.Position:=FreqEchanVoix2Defaut;
  Updown4.Position:=FreqEchanVoix3Defaut;
  Updown5.Position:=FreqEchanVoix4Defaut;
  Updown6.Position:=PoidsVoix1Defaut;
  Updown7.Position:=PoidsVoix2Defaut;
  Updown8.Position:=PoidsVoix3Defaut;
  Updown9.Position:=PoidsVoix4Defaut;
  Updown10.Position:=PoidsFichier1Defaut;
  Updown11.Position:=PoidsFichier2Defaut;
  Updown12.Position:=PoidsFichier3Defaut;
  Updown13.Position:=PoidsFichier4Defaut;
  Updown14.Position:=PoidsFichier5Defaut;
  Updown15.Position:=PosTetLectInfDefaut;
  Updown16.Position:=PosTetLectSupDefaut;
end;

procedure TFenetre.QuitterClick(Sender: TObject);
begin
  Close;
end;

procedure TFenetre.SaveClick(Sender: TObject);
var
  SaveFile: file of Integer;
  CurrentFile: String;
begin
  if SaveDialog.Execute then begin
    CurrentFile:=SaveDialog.FileName;
    AssignFile(SaveFile, CurrentFile);
    try
      Rewrite(SaveFile);
      Write(SaveFile, NbVoies,
                      NbVoix,
                      FreqEchanVoix1,
                      FreqEchanVoix2,
                      FreqEchanVoix3,
                      FreqEchanVoix4,
                      PoidsVoix1,
                      PoidsVoix2,
                      PoidsVoix3,
                      PoidsVoix4,
                      PoidsFichier1,
                      PoidsFichier2,
                      PoidsFichier3,
                      PoidsFichier4,
                      PoidsFichier5,
                      PosTetLectInf,
                      PosTetLectSup);
    finally
      CloseFile(SaveFile);
    end;
  end;
end;

procedure TFenetre.LoadClick(Sender: TObject);
var
  LoadFile: file of Integer;
  CurrentFile: String;
  NbVoiesLect,
  NbVoixLect,
  FreqEchanVoix1Lect,
  FreqEchanVoix2Lect,
  FreqEchanVoix3Lect,
  FreqEchanVoix4Lect,
  PoidsVoix1Lect,
  PoidsVoix2Lect,
  PoidsVoix3Lect,
  PoidsVoix4Lect,
  PoidsFichier1Lect,
  PoidsFichier2Lect,
  PoidsFichier3Lect,
  PoidsFichier4Lect,
  PoidsFichier5Lect,
  PosTetLectInfLect,
  PosTetLectSupLect : Integer;
begin
  if OpenDialog.Execute then begin
    CurrentFile:=OpenDialog.FileName;
    AssignFile(LoadFile, CurrentFile);
    try
      Reset(LoadFile);
      Read(LoadFile, NbVoiesLect,
                     NbVoixLect,
                     FreqEchanVoix1Lect,
                     FreqEchanVoix2Lect,
                     FreqEchanVoix3Lect,
                     FreqEchanVoix4Lect,
                     PoidsVoix1Lect,
                     PoidsVoix2Lect,
                     PoidsVoix3Lect,
                     PoidsVoix4Lect,
                     PoidsFichier1Lect,
                     PoidsFichier2Lect,
                     PoidsFichier3Lect,
                     PoidsFichier4Lect,
                     PoidsFichier5Lect,
                     PosTetLectInfLect,
                     PosTetLectSupLect);
    if (NbVoiesLect>=UpDown0.Min)
    and (NbVoiesLect<=UpDown0.Max)
    and (NbVoixLect>=UpDown1.Min)
    and (NbVoixLect<=UpDown1.Max)
    and (FreqEchanVoix1Lect>=UpDown2.Min)
    and (FreqEchanVoix1Lect<=UpDown2.Max)
    and (FreqEchanVoix2Lect>=UpDown3.Min)
    and (FreqEchanVoix2Lect<=UpDown3.Max)
    and (FreqEchanVoix3Lect>=UpDown4.Min)
    and (FreqEchanVoix3Lect<=UpDown4.Max)
    and (FreqEchanVoix4Lect>=UpDown5.Min)
    and (FreqEchanVoix4Lect<=UpDown5.Max)
    and (PoidsVoix1Lect>=UpDown6.Min)
    and (PoidsVoix1Lect<=UpDown6.Max)
    and (PoidsVoix2Lect>=UpDown7.Min)
    and (PoidsVoix2Lect<=UpDown7.Max)
    and (PoidsVoix3Lect>=UpDown8.Min)
    and (PoidsVoix3Lect<=UpDown8.Max)
    and (PoidsVoix4Lect>=UpDown9.Min)
    and (PoidsVoix4Lect<=UpDown9.Max)
    and (PoidsFichier1Lect>=UpDown10.Min)
    and (PoidsFichier1Lect<=UpDown10.Max)
    and (PoidsFichier2Lect>=UpDown11.Min)
    and (PoidsFichier2Lect<=UpDown11.Max)
    and (PoidsFichier3Lect>=UpDown12.Min)
    and (PoidsFichier3Lect<=UpDown12.Max)
    and (PoidsFichier4Lect>=UpDown13.Min)
    and (PoidsFichier4Lect<=UpDown13.Max)
    and (PoidsFichier5Lect>=UpDown14.Min)
    and (PoidsFichier5Lect<=UpDown14.Max)
    and (PosTetLectInfLect>=Updown15.Min)
    and (PosTetLectInfLect<=Updown15.Max)
    and (PosTetLectSupLect>=Updown16.Min)
    and (PosTetLectSupLect<=Updown16.Max)
    then begin
      Updown0.Position:=NbVoiesLect;
      Updown1.Position:=NbVoixLect;
      Updown2.Position:=FreqEchanVoix1Lect;
      Updown3.Position:=FreqEchanVoix2Lect;
      Updown4.Position:=FreqEchanVoix3Lect;
      Updown5.Position:=FreqEchanVoix4Lect;
      Updown6.Position:=PoidsVoix1Lect;
      Updown7.Position:=PoidsVoix2Lect;
      Updown8.Position:=PoidsVoix3Lect;
      Updown9.Position:=PoidsVoix4Lect;
      Updown10.Position:=PoidsFichier1Lect;
      Updown11.Position:=PoidsFichier2Lect;
      Updown12.Position:=PoidsFichier3Lect;
      Updown13.Position:=PoidsFichier4Lect;
      Updown14.Position:=PoidsFichier5Lect;
      Updown15.Position:=PosTetLectInfLect;
      Updown16.Position:=PosTetLectSupLect;
    end;
    finally
      CloseFile(LoadFile);
    end;
  end;
end;






end.
