unit TestConfigForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ShellApi;

type
  TTestConfig = class(TForm)
    RichEdit: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  TestConfig: TTestConfig;

function FichierSon: Boolean;

implementation

uses
  SplashForm, FenetreForm, Outils;

{$R *.DFM}

function FichierSon: Boolean;
var
  Chemin: String;
begin
  Result:=False;
  Chemin:=GetCurrentDirectoryPath;
  if Chemin[Length(Chemin)]<>'\' then Chemin:=Chemin+'\';
  if FileExists(Chemin+'1.wav') then
  if FileExists(Chemin+'2.wav') then
  if FileExists(Chemin+'3.wav') then
  if FileExists(Chemin+'4.wav') then
  if FileExists(Chemin+'5.wav') then Result:=True;
end;

procedure TTestConfig.FormCreate(Sender: TObject);
var
  User: String;
begin
  if (GetRegistration(User)) and (FichierSon) then begin
    Application.CreateForm(TFenetre, Fenetre);
    TestConfig.Close;
    TestConfig.Release;
  end
  else begin
    TestConfig.Width:=400;
    TestConfig.Height:=300;
    with RichEdit do begin
      Width:=TestConfig.Width-100;
      Left:=-3+(TestConfig.Width-Width) Div 2;
      Height:=271;
      Top:=-12+(TestConfig.Height-Height) Div 2;
      Lines.Clear;
      Lines.Add('');
      Lines.Add('');
      Lines.Add('');
      if Not GetRegistration(User) then begin
        Lines.Add('Version non enregistre : installez la dernire version de l''interface de lit&ratique tlchargeable sur http://perso.wanadoo.fr/eric.serandour et enregistrez vous auprs de son auteur.');
        Lines.Add('');
      end;
      if Not FichierSon then
      Lines.Add('Il manque un ou plusieurs fichiers sonores ncessaires  l''excution de r.');
    end;
  end;
end;


procedure TTestConfig.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then Close;
end;

end.
